program TokenTest;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,

  Bcl.Jose.Core.Base,
  Bcl.Jose.Core.JWA,
  Bcl.Jose.Consumer,
  Bcl.Jose.Core.Builder;

begin
  try
    var Token := 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpYXQiOjE3MDEyNTcxMzYsImlzcyI6Ik1hZW5rZW4uU3lzdGVtcyIsImp0aSI6IjFhZTJkNzllLTQ0NWUtNDM1YS05ZjVkLWE0NDVhYzc2NjE0MiIsIlRZUEUiOiJMT0MiLCJ1c2VybmFtZSI6IiIsImlkdXNlciI6IjFhZTJkNzllLTQ0NWUtNDM'+
                 '1YS05ZjVkLWE0NDVhYzc2NjE0MiIsImRvbWFpbmlkIjoiOGI3MTJlMzctYWEyZC00NGU1LTgzMTMtNWI3ZTM4MjQwMTE2IiwiZG9tYWluIjoiIiwiQXBpVG9rZW4iOnRydWV9.yk2XLGIEWL07qTaJnv8St3FkFoJ6bq3mSESUjB1c1iw';

    var LocalSecret := 'dsfgsfdcdfgtew5xer459786KZUZG&iuzGzgGII(IUGi3f6756ve5vze4dfhzgu()GTZgiuz/ritzgfuzgiut6zZGHZTkzhkuzh666g6i7IGIZdrzhdrfz4e556z4e645e674567886887';

    var FLocalSecret := TEncoding.UTF8.GetBytes(LocalSecret);
    var JWT := TJOSE.DeserializeOnly(Token);

    try
      var Builder: IJOSEConsumerBuilder;

      if (assigned(JWT.Claims.JSON.Values['TYPE']) and (JWT.Claims.JSON.Values['TYPE'].AsType < string >= 'LOC')) then
      begin
        // Build consumer for LocalSecret
        Builder := TJOSEConsumerBuilder.NewConsumer.SetVerificationKey
          (FLocalSecret).SetExpectedAlgorithms([TJOSEAlgorithmId.HS256]);
      end
      else
      begin
        // Build consumer for AppSecret
      end;

      Builder.SetAllowedClockSkew(0, TJOSETimeUnit.Seconds);

      Builder.SetRequireIssuedAt;

      var Consumer := Builder.Build;
      Consumer.Process(Token); // <<< JWS signature is invalid: yk2XLGIEWL07qTaJnv8St3FkFoJ6bq3mSESUjB1c1iw

      // ...
    finally
      JWT.Free;
    end;

  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
